6 GPG_CMD
="gpg --ignore-time-conflict --no-options --no-default-keyring"
8 # gpg needs (in different versions more or less) files to function correctly,
9 # so we give it its own homedir and generate some valid content for it
10 GPGHOMEDIR
="$(mktemp -d)"
11 CURRENTTRAP
="${CURRENTTRAP} rm -rf '${GPGHOMEDIR}';"
12 trap "${CURRENTTRAP}" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
13 chmod 700 "$GPGHOMEDIR"
14 # We don't use a secret keyring, of course, but gpg panics and
15 # implodes if there isn't one available - and writeable for imports
16 SECRETKEYRING
="${GPGHOMEDIR}/secring.gpg"
18 GPG_CMD
="$GPG_CMD --homedir $GPGHOMEDIR"
19 # create the trustdb with an (empty) dummy keyring
20 # older gpgs required it, newer gpgs even warn that it isn't needed,
21 # but require it nonetheless for some commands, so we just play safe
22 # here for the foreseeable future and create a dummy one
23 $GPG_CMD --quiet --check-trustdb --keyring $SECRETKEYRING >/dev
/null
2>&1
24 # tell gpg that it shouldn't try to maintain a trustdb file
25 GPG_CMD
="$GPG_CMD --no-auto-check-trustdb --trust-model always"
30 eval $(apt-config shell APT_DIR Dir)
32 MASTER_KEYRING
='&keyring-master-filename;'
33 eval $(apt-config shell MASTER_KEYRING APT::Key::MasterKeyring)
34 ARCHIVE_KEYRING
='&keyring-filename;'
35 eval $(apt-config shell ARCHIVE_KEYRING APT::Key::ArchiveKeyring)
36 REMOVED_KEYS
='&keyring-removed-filename;'
37 eval $(apt-config shell REMOVED_KEYS APT::Key::RemovedKeys)
38 ARCHIVE_KEYRING_URI
='&keyring-uri;'
39 eval $(apt-config shell ARCHIVE_KEYRING_URI APT::Key::ArchiveKeyringURI)
40 TMP_KEYRING
=${APT_DIR}/var
/lib
/apt
/keyrings
/maybe
-import-keyring.gpg
42 aptkey_echo
() { echo "$@"; }
45 if [ "$(id -u)" -ne 0 ]; then
46 echo >&2 "ERROR: This command can only be used by root."
51 add_keys_with_verify_against_master_keyring
() {
55 if [ ! -f "$ADD_KEYRING" ]; then
56 echo >&2 "ERROR: '$ADD_KEYRING' not found"
59 if [ ! -f "$MASTER" ]; then
60 echo >&2 "ERROR: '$MASTER' not found"
64 # when adding new keys, make sure that the archive-master-keyring
66 # all keys that are exported must have a valid signature
67 # from a key in the $distro-master-keyring
68 add_keys
=`$GPG_CMD --keyring $ADD_KEYRING --with-colons --list-keys | grep ^pub | cut -d: -f5`
69 all_add_keys
=`$GPG_CMD --keyring $ADD_KEYRING --with-colons --list-keys | grep ^[ps]ub | cut -d: -f5`
70 master_keys
=`$GPG_CMD --keyring $MASTER --with-colons --list-keys | grep ^pub | cut -d: -f5`
72 # ensure there are no colisions LP: #857472
73 for all_add_key
in $all_add_keys; do
74 for master_key
in $master_keys; do
75 if [ "$all_add_key" = "$master_key" ]; then
76 echo >&2 "Keyid collision for '$all_add_key' detected, operation aborted"
82 for add_key
in $add_keys; do
83 # export the add keyring one-by-one
85 $GPG_CMD --keyring $ADD_KEYRING --output $TMP_KEYRING --export $add_key
86 # check if signed with the master key and only add in this case
88 for master_key
in $master_keys; do
89 if $GPG_CMD --keyring $MASTER --keyring $TMP_KEYRING --check-sigs --with-colons $add_key | grep '^sig:!:' | cut
-d: -f5 | grep -q $master_key; then
90 $GPG --import $TMP_KEYRING
94 if [ $ADDED = 0 ]; then
95 echo >&2 "Key '$add_key' not added. It is not signed with a master key"
101 # update the current archive signing keyring from a network URI
102 # the archive-keyring keys needs to be signed with the master key
103 # (otherwise it does not make sense from a security POV)
105 # Disabled for now as code is insecure (LP: #1013639 (and 857472, 1013128))
106 APT_KEY_NET_UPDATE_ENABLED
=""
107 eval $(apt-config shell APT_KEY_NET_UPDATE_ENABLED APT::Key::Net-Update-Enabled)
108 if [ -z "$APT_KEY_NET_UPDATE_ENABLED" ]; then
112 if [ -z "$ARCHIVE_KEYRING_URI" ]; then
113 echo >&2 "ERROR: Your distribution is not supported in net-update as no uri for the archive-keyring is set"
117 # in theory we would need to depend on wget for this, but this feature
118 # isn't useable in debian anyway as we have no keyring uri nor a master key
119 if ! which wget
>/dev
/null
2>&1; then
120 echo >&2 "ERROR: an installed wget is required for a network-based update"
123 if [ ! -d ${APT_DIR}/var
/lib
/apt
/keyrings
]; then
124 mkdir -p ${APT_DIR}/var
/lib
/apt
/keyrings
126 keyring
=${APT_DIR}/var
/lib
/apt
/keyrings
/$(basename $ARCHIVE_KEYRING_URI)
128 if [ -e $keyring ]; then
129 old_mtime
=$(stat -c %Y $keyring)
131 (cd ${APT_DIR}/var
/lib
/apt
/keyrings
; wget
--timeout=90 -q -N $ARCHIVE_KEYRING_URI)
132 if [ ! -e $keyring ]; then
135 new_mtime
=$(stat -c %Y $keyring)
136 if [ $new_mtime -ne $old_mtime ]; then
137 aptkey_echo
"Checking for new archive signing keys now"
138 add_keys_with_verify_against_master_keyring
$keyring $MASTER_KEYRING
143 if [ ! -f $ARCHIVE_KEYRING ]; then
144 echo >&2 "ERROR: Can't find the archive-keyring"
145 echo >&2 "Is the &keyring-package; package installed?"
150 # add new keys from the package;
152 # we do not use add_keys_with_verify_against_master_keyring here,
153 # because "update" is run on regular package updates. A
154 # attacker might as well replace the master-archive-keyring file
155 # in the package and add his own keys. so this check wouldn't
156 # add any security. we *need* this check on net-update though
157 $GPG_CMD --quiet --batch --keyring $ARCHIVE_KEYRING --export | $GPG --import
159 if [ -r "$REMOVED_KEYS" ]; then
160 # remove no-longer supported/used keys
161 keys
=`$GPG_CMD --keyring $REMOVED_KEYS --with-colons --list-keys | grep ^pub | cut -d: -f5`
163 if $GPG --list-keys --with-colons | grep ^pub
| cut
-d: -f5 | grep -q $key; then
164 $GPG --quiet --batch --delete-key --yes ${key}
168 echo >&2 "Warning: removed keys keyring $REMOVED_KEYS missing or not readable"
172 remove_key_from_keyring
() {
173 local KEYRINGFILE
="$1"
175 local GPG
="$GPG_CMD --keyring $KEYRINGFILE"
176 while [ -n "$1" ]; do
179 # check if the key is in this keyring: the key id is in the 5 column at the end
180 if ! $GPG --with-colons --list-keys 2>&1 | grep -q "^pub:[^:]*:[^:]*:[^:]*:[0-9A-F]\+${KEY}:"; then
183 if [ ! -w "$KEYRINGFILE" ]; then
184 echo >&2 "Key ${KEY} is in keyring ${KEYRINGFILE}, but can't be removed as it is read only."
187 # check if it is the only key in the keyring and if so remove the keyring altogether
188 if [ '1' = "$($GPG --with-colons --list-keys | grep "^pub:[^:]*:[^:]*:[^:]*:[0-9A-F]\+:" | wc -l)" ]; then
189 mv -f "$KEYRINGFILE" "${KEYRINGFILE}~" # behave like gpg
192 # we can't just modify pointed to files as these might be in /usr or something
194 if [ -L "$KEYRINGFILE" ]; then
195 REALTARGET
="$(readlink -f "$KEYRINGFILE")"
196 mv -f "$KEYRINGFILE" "${KEYRINGFILE}.dpkg-tmp"
197 cp -a "$REALTARGET" "$KEYRINGFILE"
199 # delete the key from the keyring
200 $GPG --batch --delete-key --yes "$KEY"
201 if [ -n "$REALTARGET" ]; then
202 # the real backup is the old link, not the copy we made
203 mv -f "${KEYRINGFILE}.dpkg-tmp" "${KEYRINGFILE}~"
210 foreach_keyring_do
'remove_key_from_keyring' "$@"
214 foreach_keyring_do
() {
217 # if a --keyring was given, just remove from there
218 if [ -n "$FORCED_KEYRING" ]; then
219 $ACTION "$FORCED_KEYRING" "$@"
221 # otherwise all known keyrings are up for inspection
222 local TRUSTEDFILE
="/etc/apt/trusted.gpg"
223 eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring)
224 eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f)
225 $ACTION "$TRUSTEDFILE" "$@"
226 local TRUSTEDPARTS
="/etc/apt/trusted.gpg.d"
227 eval $(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)
228 if [ -d "$TRUSTEDPARTS" ]; then
229 for trusted
in $(run-parts --list "$TRUSTEDPARTS" --regex '^.*\.gpg$'); do
230 $ACTION "$trusted" "$@"
237 echo "Usage: apt-key [--keyring file] [command] [arguments]"
239 echo "Manage apt's list of trusted keys"
241 echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)"
242 echo " apt-key del <keyid> - remove the key <keyid>"
243 echo " apt-key export <keyid> - output the key <keyid>"
244 echo " apt-key exportall - output all trusted keys"
245 echo " apt-key update - update keys using the keyring package"
246 echo " apt-key net-update - update keys using the network"
247 echo " apt-key list - list keys"
248 echo " apt-key finger - list fingerprints"
249 echo " apt-key adv - pass advanced options to gpg (download key)"
251 echo "If no specific keyring file is given the command applies to all keyring files."
254 while [ -n "$1" ]; do
260 if [ -r "$TRUSTEDFILE" ] || [ "$2" = 'add' ] || [ "$2" = 'adv' ]; then
261 GPG
="$GPG --keyring $TRUSTEDFILE --primary-keyring $TRUSTEDFILE"
263 echo >&2 "Error: The specified keyring »$TRUSTEDFILE« is missing or not readable"
269 requires_root
() { true
; }
273 aptkey_echo
() { true
; }
277 echo >&2 "Unknown option: $1"
285 if [ -z "$TRUSTEDFILE" ]; then
286 TRUSTEDFILE
="/etc/apt/trusted.gpg"
287 eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring)
288 eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f)
289 if [ -r "$TRUSTEDFILE" ]; then
290 GPG
="$GPG --keyring $TRUSTEDFILE"
291 GPG
="$GPG --primary-keyring $TRUSTEDFILE"
293 TRUSTEDPARTS
="/etc/apt/trusted.gpg.d"
294 eval $(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)
295 if [ -d "$TRUSTEDPARTS" ]; then
296 # strip / suffix as gpg will double-slash in that case (#665411)
297 STRIPPED_TRUSTEDPARTS
="${TRUSTEDPARTS%/}"
298 if [ "${STRIPPED_TRUSTEDPARTS}/" = "$TRUSTEDPARTS" ]; then
299 TRUSTEDPARTS
="$STRIPPED_TRUSTEDPARTS"
301 for trusted
in $(run-parts --list "$TRUSTEDPARTS" --regex '^.*\.gpg$'); do
302 GPG
="$GPG --keyring $trusted"
308 if [ -z "$command" ]; then
314 if [ "$command" != "help" ]; then
315 if ! which gpg
>/dev
/null
2>&1; then
316 echo >&2 "Warning: gnupg does not seem to be installed."
317 echo >&2 "Warning: apt-key requires gnupg for most operations."
321 # gpg defaults to mode 0600 for new keyrings. Create one with 0644 instead.
322 if ! [ -e "$TRUSTEDFILE" ]; then
323 if [ -w "$(dirname "$TRUSTEDFILE")" ]; then
324 touch -- "$TRUSTEDFILE"
325 chmod 0644 -- "$TRUSTEDFILE"
326 GPG
="$GPG --keyring $TRUSTEDFILE"
327 GPG
="$GPG --primary-keyring $TRUSTEDFILE"
335 $GPG --quiet --batch --import "$@"
348 $GPG --batch --list-keys "$@"
351 $GPG --batch --fingerprint "$@"
354 $GPG --armor --export "$@"
357 aptkey_echo
"Executing: $GPG $*"